/**
Master Project WS-2004 ~ SS 2005, Computer Science

University of Fribourg, Information Systems Research Group (http://diuf.unifr.ch/is)

Student :    Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>
Supervisors: Prof. Dr. Andreas Meier <andreas.meier@unifr.ch>
             Nicolas Werro <nicolas.werro@unifr.ch>
        __  __
 _ _ ___\ \/ /__ _ _ _  _ _  ___
| '_/ _ \>  </ _` | ' \| ' \/ -_)
|_| \___/_/\_\__,_|_||_|_||_\___|

roXanne, Secure XML Data Storage Framework
x.core & x.click Copyright (C) 2004-2005 Amos Brocco <amos.brocco@unifr.ch>
x.mill Copyright (C) 2004-2005 Andrea Ghirlanda <andrea.ghirlanda@unifr.ch>

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

This product includes software developed by the JDOM Project (http://www.jdom.org/).
The Jaxup library is Copyright (c) 2001 - 2003 Erwin Bolwidt, used and modified under the BSD License.
Encryption modules used are Copyright (c) 2000 - 2004 The Legion Of The Bouncy Castle (http://www.bouncycastle.org).
JAXEN  is Copyright 2003 (C) The Werken Company. All Rights Reserved.
Base64 was released as Public Domain by its author Robert Harder (rob@iharder.net)
MySQL JDBC Connector is (c) 1995-2005 MySQL AB. All rights reserved. Released under the GNU/GPL License.
PostgreSQL JDBC Driver is Copyright (c) 2004-2005 The PostgreSQL Global Development Group, distributed under the BSD license
JArgs was created Steve Purcell, now mantained by Ewan Mellorby and released under the BSD licence.
**/

package support;

/**
 * @author ghigo
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
import java.io.IOException;
import java.io.StringWriter;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Properties;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Text;
import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

import com.sun.org.apache.xml.internal.serialize.OutputFormat;
import com.sun.org.apache.xml.internal.serialize.XMLSerializer;

public class ImportFromMySQL implements ImportInterface {

	boolean processTablesOnly;

	boolean processDataOnly;

	/**
	 * Variables globals
	 */

	ResultSet casb = null;

	ResultSet casb1 = null;

	ResultSet casb2 = null;

	Connection conn;

	DocumentBuilder db;

	DocumentBuilderFactory dbf;

	DatabaseMetaData dbmd = null;

	DatabaseMetaData dbmd1 = null;

	Document document;

	ResultSetMetaData md = null;

	ResultSetMetaData md1 = null;

	ResultSetMetaData md2 = null;

	ResultSet resultSet = null;

	Statement stat;

	String tableName = null;

	String Database = null;

	boolean getInformationDb;

	Vector tablesToExportStructure = new Vector();

	Vector tablesToExportData = new Vector();

	boolean continueOnTableNotFound = false;

	boolean continueOnDatabaseNotFound = false;

	boolean continueOnErrorGeneral = false;

	private String resultXML;

	private String database;

	private Text log;

	public ImportFromMySQL() {
		/**
		 * TODO: impostare parametri per la connessione TODO: impostare metodi e
		 * variabili per eventi speciali
		 */

	}

	/**
	 * 
	 * 
	 * Funzione per aggiungere un nodo all'abero XML, tipo2
	 * 
	 * @param N
	 * @param profondeur
	 * @return
	 */

	private static String affichage(Node N, int profondeur) throws Exception {
		String ret = "";
		Node fils;
		if (N != null) {
			if (N.hasChildNodes()) {
				//Premier enfant
				fils = N.getFirstChild();
				while (fils != null) {
					//ici le traitement specifique
					ret += "\n";
					for (int i = 0; i <= profondeur; i++)
						ret += "\t";
					//Pour recuperer la valeur d'un attribut :
					ret += ((Element) fils).getAttribute("name") + " "
							+ ((Element) fils).getAttribute("texte");

					//recurrence : affiche les enfants de fils.
					ret += affichage(fils, profondeur + 1);
					//Passe au frere suivant
					fils = fils.getNextSibling();
				}
			}
		}
		return ret;
	}

	/**
	 * 
	 * Metod to append node type1
	 * 
	 * 
	 * @param parent
	 * @param nomenodo
	 * @param valeur1
	 * @return
	 */

	private static Node ajoutNoeud(Node parent, String nomenodo, String valeur1)
			throws Exception {
		Element element = parent.getOwnerDocument().createElement(nomenodo);
		element.setAttribute("name", valeur1);

		parent.appendChild(element);
		return element;

	}

	/**
	 * Metod to append node type2
	 * 
	 * @param parent
	 * @param nomenodo
	 * @return
	 */

	private static Node ajoutNoeud1(Node parent, String nomenodo)
			throws Exception {

		Element element = parent.getOwnerDocument().createElement(nomenodo);

		parent.appendChild(element);
		return element;

	}

	/**
	 * Converter character
	 * 
	 * @param string
	 * @return
	 */
	private static String stringToHTMLString(String string) throws Exception {
		StringBuffer sb = new StringBuffer(string.length());
		// true if last char was blank
		boolean lastWasBlankChar = false;
		int len = string.length();
		char c;

		for (int i = 0; i < len; i++) {
			c = string.charAt(i);
			if (c == ' ') {
				// blank gets extra work,
				// this solves the problem you get if you replace all
				// blanks with &nbsp;, if you do that you loss
				// word breaking
				if (lastWasBlankChar) {
					lastWasBlankChar = false;
					sb.append("&nbsp;");
				} else {
					lastWasBlankChar = true;
					sb.append(' ');
				}
			} else {
				lastWasBlankChar = false;

				// HTML Special Chars
				if (c == '"')
					sb.append("&quot;");
				else if (c == '&')
					sb.append("&amp;");
				else if (c == '<')
					sb.append("&lt;");
				else if (c == '>')
					sb.append("&gt;");
				else if (c == '\n')
					// Handle Newline
					sb.append("&lt;br/&gt;");
				else {
					int ci = 0xffff & c;
					if (ci < 160)
						// nothing special only 7 Bit
						sb.append(c);
					else {
						// Not 7 Bit use the unicode system
						sb.append("&#");
						sb.append(new Integer(ci).toString());
						sb.append(';');
					}
				}
			}
		}
		return sb.toString();
	}

	private void printError(String error) throws Exception {
		final String theerror = error;
		if(!(log==null)) {
		/* Sync start */Display.getCurrent().syncExec(new Runnable() {
			public void run() {
				log.append("Error: "+ theerror+" \n");
			}});
		}
		throw new Exception(theerror);
	}
	
	
	private void printMessage(String message) throws Exception {
		final String themessage = message;
		if(!(log==null)) {
		/* Sync start */Display.getCurrent().syncExec(new Runnable() {
			public void run() {
				log.append(themessage+"\n");
			}});
		}
	}
	
	
	public void setLogText(Text logtext) {
		this.log = logtext;
	}
	/**
	 * 
	 * @param source
	 */

	private void doExportData() throws Exception {
	
		initDataTree();
	
		OutputFormat format = new OutputFormat(document);
		//		 as a String
		StringWriter stringOut = new StringWriter();
		XMLSerializer serial = new XMLSerializer(stringOut, format);
		try {
			serial.serialize(document);
		} catch (IOException e) {
			
			if (continueOnErrorGeneral)
				printError("Error reading XML:\n"+e.getMessage());
			else
				throw new Exception("Error reading XML:\n"+e.getMessage());
		}
		//		 Display the XML
		resultXML = stringOut.toString();
		
	}

	/**
	 * Inizialitation connection
	 * 
	 * @param url
	 * @param prop
	 */

	private void initConnection(String url, Properties prop) throws Exception {
		try {
			// Register MySQL driver
			Class.forName("com.mysql.jdbc.Driver").newInstance();
			// Open a properties file where connection info is store
			conn = DriverManager.getConnection(url, prop);
			stat = conn.createStatement();
		} catch (Exception ex) {
			if (continueOnErrorGeneral)
				printError("Error connection databases:\n"+ex.getMessage());
			else
				throw new Exception("Error connection databases:\n"+ex.getMessage());
		}
	}

	/**
	 * initialisation tree
	 * 
	 * @param database
	 */
	private void initDataTree() throws Exception {
		printMessage("Initializing XML tree");
		dbf = DocumentBuilderFactory.newInstance();
		try {
			db = dbf.newDocumentBuilder();
		} catch (ParserConfigurationException e) {
			if (continueOnErrorGeneral)
				printError("Error creating tree: \n"+e.getMessage());
			else
				throw new Exception("Error creating tree: \n"+e.getMessage());
		}
		document = db.newDocument();

		//creé un Node racine
		printMessage("Creating root node");
		Node racine = document.createElement("database");

		((Element) racine).setAttribute("name", database);

		document.appendChild(racine);
		processChildRoot(racine);

	}

	/**
	 * 
	 * 
	 * @param racine
	 * 
	 * 
	 * 
	 * <database name="agenzia"> - * <tables name="table"> </tables>- * <DbInfos
	 * name="informationDbDataType"> </DbInfos> </database>
	 *  
	 */

	private void processChildRoot(Node racine) throws Exception {
		printMessage("Processing root children");
		Node noeudTab = ajoutNoeud1(racine, "tables");
		Node noeudInfoDbDataType = ajoutNoeud1(racine, "dbInfos");
		processChildTables(noeudTab);
		processNodeDataType(noeudInfoDbDataType);
	}

	/**
	 * List databases MySQL
	 */

	public Vector listDatabase() throws Exception {
		Vector listData = new Vector();

		try {
			casb = stat.executeQuery("SHOW databases;");

			while (casb.next()) {

				listData.add(casb.getString(1));
			}

		} catch (SQLException e) {
			if (continueOnErrorGeneral)
				printError("Error list database, problem connection : \n"+e.getMessage());
			else
				throw new Exception("Error list database, problem connection : \n"+e.getMessage());
		}

		return listData;

	}

	/**
	 * Return liste table database
	 */

	public Vector listTables() throws Exception {

		Vector listTab = new Vector();

		try {
			dbmd = conn.getMetaData();
		} catch (SQLException e) {
			if (continueOnErrorGeneral)
				printError("Error list tables, databases not found :\n"+e.getMessage());
			else
				throw new Exception("Error list tables, databases not found :\n"+e.getMessage());
		}
		// Specify the type of object; in this case we want tables
		String[] types = { "TABLES" };

		ResultSet resultSet = null;
		try {
			resultSet = dbmd.getTables("", "", "%", types);
		} catch (SQLException e1) {
			
			if (continueOnErrorGeneral)
				printError("Error list tables, databases not found: \n"+e1.getMessage());
			else
				throw new Exception("Error list tables, databases not found: \n"+e1.getMessage());
			
			
			
			

		}

		try {
			while (resultSet.next()) {

				tableName = resultSet.getString(3);
				listTab.add(tableName);

			}
		} catch (SQLException e2) {
			
			if (continueOnErrorGeneral)
				printError("Error list tables, databases not found :\n"+e2.getMessage());
			else
				throw new Exception("Error list tables, databases not found :\n"+e2.getMessage());
			
			
			
			

		}

		return listTab;
	}


	 

	/**
	 * Select database
	 */
	public boolean selectDatabase(String database) throws Exception {
		try {
			casb = stat.executeQuery("USE " + database);

		} catch (SQLException e) {
			if (continueOnDatabaseNotFound)
				printError("Error databases not found:\n"+e.getMessage());
			else
				throw new Exception("Error databases not found:\n"+e.getMessage());
			
			
			
			return false;
		}
		this.database = database;
		return true;
	}

	/**
	 * 
	 * @param noeudTab
	 * 
	 * 
	 * 
	 * 
	 * 
	 * <database name="agenzia"> - * <tables name="table"> <tableName name="t1">
	 * </tableName>
	 * 
	 * <tableName name="t2"> </tableName>
	 * 
	 * <tableName name="t3"> </tableName>
	 * 
	 * <tableName name="tn"> </tableName> </tables>- * <DbInfos
	 * name="informationDbDataType"> </DbInfos> </database>
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 *  
	 */

	private void processChildTables(Node noeudTab) throws Exception {
		printMessage("Processing tables");
		try {
			dbmd = conn.getMetaData();
		} catch (SQLException e) {
			printError("Error string SQL");
			e.printStackTrace();
		}
		// Specify the type of object; in this case we want tables
		String[] types = { "TABLE" };

		ResultSet resultSet = null;
		try {
			resultSet = dbmd.getTables("", "", "%", types);
		} catch (SQLException e1) {
			if (continueOnErrorGeneral)
				printError("Error creating tree:\n"+e1.getMessage());
			else
				throw new Exception("Error creating tree:\n"+e1.getMessage());
		}

		try {
			while (resultSet.next()) {

				tableName = resultSet.getString(3);
				if (tablesToExportData.contains(tableName)
						|| (tablesToExportStructure.contains(tableName))) {
					Node noeudNomiTab = ajoutNoeud(noeudTab, "tableName",
							tableName);
					printMessage("Processing table: "+tableName);
					processNodeInformationField(noeudNomiTab, tableName);
				}

			}
		} catch (SQLException e2) {
			if (continueOnErrorGeneral)
				printError("Error creating tree:\n"+e2.getMessage());
			else
				throw new Exception("Error creating tree:\n"+e2.getMessage());
		}

	}

	/**
	 * 
	 * @param noeudCol
	 * 
	 * 
	 * 
	 * 
	 * <database name="agenzia"> - * <tables name="table"> <tableName name="t1">
	 * <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> </Column> <Column IsAutoIncrement="..." IsNullable="..."
	 * Size="..." Type="..." name="..."> </Column>
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t1"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="t2"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * </Column> <Column IsAutoIncrement="..." IsNullable="..." Size="..."
	 * Type="..." name="..."> </Column>
	 * 
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t2"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * </entry> </entries> </tableName>
	 * 
	 * <tableName name="t3"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * </Column> <Column IsAutoIncrement="..." IsNullable="..." Size="..."
	 * Type="..." name="..."> </Column> </information> <entries
	 * name="EntriesTable"> <entry name="t3"> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> </entry> </entries>
	 * </tableName>
	 * 
	 * <tableName name="tn"> <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> </Column> <Column IsAutoIncrement="..." IsNullable="..."
	 * Size="..." Type="..." name="..."> </Column> </information> <entries
	 * name="EntriesTable">
	 * 
	 * <entry name="tn"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName> </tables> <DbInfos
	 * name="informationDbDataType"> </DbInfos> </database>
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 *  
	 */

	private void processNodeColumn(Node noeudCol) throws Exception {
		printMessage("Processing column from table " +tableName);
		try {
			casb1 = stat.executeQuery("SELECT * FROM " + tableName);

		} catch (SQLException e) {
			if (continueOnTableNotFound)
				printError("Error table not found:\n"+e.getMessage());
			else
				throw new Exception("Error table not found:\n"+e.getMessage());
		}

		try {
			md2 = casb1.getMetaData();
		} catch (SQLException e1) {
			if (continueOnTableNotFound)
				printError("Error table not found:\n"+e1.getMessage());
			else
				throw new Exception("Error table not found:\n"+e1.getMessage());
		}

		int numeroColonne = 0;
		try {
			numeroColonne = casb1.getMetaData().getColumnCount();
		} catch (SQLException e7) {
			if (continueOnTableNotFound)
				printError("Error table not found:\n"+e7.getMessage());
			else
				throw new Exception("Error table not found:\n"+e7.getMessage());
		}

		for (int a = 1; a <= numeroColonne; a++) {

			Node noeudNomeCol = null;

			try {
				noeudNomeCol = ajoutNoeud(noeudCol, "column", md2
						.getColumnName(a));
			} catch (SQLException e6) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e6.getMessage());
				else
					throw new Exception("Error table not found:\n"+e6.getMessage());
			}
			try {
				((Element) noeudNomeCol).setAttribute("type", md2
						.getColumnTypeName(a));
			} catch (DOMException e5) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e5.getMessage());
				else
					throw new Exception("Error table not found:\n"+e5.getMessage());
			} catch (SQLException e5) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e5.getMessage());
				else
					throw new Exception("Error table not found:\n"+e5.getMessage());
			}
			try {
				((Element) noeudNomeCol).setAttribute("size", Integer
						.toString(md2.getColumnDisplaySize(a)));
			} catch (DOMException e4) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e4.getMessage());
				else
					throw new Exception("Error table not found:\n"+e4.getMessage());
			} catch (SQLException e4) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e4.getMessage());
				else
					throw new Exception("Error table not found:\n"+e4.getMessage());
			}
			try {
				((Element) noeudNomeCol).setAttribute("isAutoIncrement",
						Boolean.toString(md2.isAutoIncrement(a)));
			} catch (DOMException e8) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e8.getMessage());
				else
					throw new Exception("Error table not found:\n"+e8.getMessage());
			} catch (SQLException e8) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e8.getMessage());
				else
					throw new Exception("Error table not found:\n"+e8.getMessage());
			}
			try {
				((Element) noeudNomeCol).setAttribute("isNullable", Integer
						.toString(md2.isNullable(a)));
			} catch (DOMException e3) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e3.getMessage());
				else
					throw new Exception("Error table not found:\n"+e3.getMessage());
			} catch (SQLException e3) {
				if (continueOnTableNotFound)
					printError("Error table not found:\n"+e3.getMessage());
				else
					throw new Exception("Error table not found:\n"+e3.getMessage());
			}

			ResultSet primaria1 = null;
		

			try {
			
				primaria1 = dbmd.getPrimaryKeys("", "", tableName.trim());
				
				while (primaria1.next()) {

					if (primaria1.getString("COLUMN_NAME").equals(
							md2.getColumnName(a)))

						((Element) noeudNomeCol).setAttribute("primaryKey",
								"true");
				}
			} catch (SQLException e1) {
				if (continueOnTableNotFound)
					printError("Error table not found: \n"+e1.getMessage());
				else
					throw new Exception("Error table not found: \n"+e1.getMessage());
			}

		}
	}

	/**
	 * 
	 * @param noeudEntries
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * <database name="agenzia"> - * <tables name="table"> <tableName name="t1">
	 * <information name="informatioField" </information> <entries
	 * name="EntriesTable"> <entry name="t1"> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/> <data
	 * ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="t2"> <information name="informatioField" </information>
	 * <entries name="EntriesTable"> <entry name="t2"> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> </entry> </entries>
	 * </tableName>
	 * 
	 * <tableName name="t3"> <information name="informatioField" </information>
	 * <entries name="EntriesTable"> <entry name="t3"> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> </entry> </entries>
	 * </tableName>
	 * 
	 * <tableName name="tn"> <information name="informatioField" </information>
	 * <entries name="EntriesTable">
	 * 
	 * <entry name="tn"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName> </tables> <DbInfos
	 * name="informationDbDataType"> </DbInfos> </database>
	 * 
	 *  
	 */
	private void processNodeData(Node noeudEntries) throws Exception {
			printMessage("Processing data node");
		try {

			casb1 = stat.executeQuery("SELECT * FROM " + tableName);
			md1 = casb1.getMetaData();
			while (casb1.next())

			{
				Node noeudColEnt = ajoutNoeud1(noeudEntries, "entry");

				int noCols = 0;
				try {
					noCols = casb1.getMetaData().getColumnCount();
				} catch (SQLException e1) {
					if (continueOnTableNotFound)
						printError("Error table not found:\n"+e1.getMessage());
					else
						throw new Exception("Error table not found:\n"+e1.getMessage());
				}

				for (int i = 1; i <= noCols; ++i) {

					Element element = noeudEntries.getOwnerDocument()
							.createElement("data");
					try {

						element.setAttribute("id", stringToHTMLString(md1
								.getColumnName(i)));
						element.setAttribute("value", stringToHTMLString(casb1
								.getObject(i).toString()));
					} catch (DOMException e) {
						if (continueOnTableNotFound)
							printError("Error table not found:\n"+e.getMessage());
						else
							throw new Exception("Error table not found:\n"+e.getMessage());
					} catch (SQLException e) {
						if (continueOnTableNotFound)
							printError("Error table not found:\n"+e.getMessage());
						else
							throw new Exception("Error table not found:\n"+e.getMessage());
					}
					noeudColEnt.appendChild(element);

				}
			}
		} catch (DOMException e) {
			if (continueOnTableNotFound)
				printError("Error table not found:\n"+e.getMessage());
			else
				throw new Exception("Error table not found:\n"+e.getMessage());
		} catch (SQLException e) {
			if (continueOnTableNotFound)
				printError("Error table not found:\n"+e.getMessage());
			else
				throw new Exception("Error table not found:\n"+e.getMessage());
		}
	}

	/**
	 * 
	 *  * <database name="agenzia"> - * <tables name="table"> <tableName
	 * name="t1"> <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="..."/> </Column>
	 * 
	 * 
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="..."/> </Column>
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t1"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="t2"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="..."/> </Column> <Column IsAutoIncrement="..."
	 * IsNullable="..." Size="..." Type="..." name="..."> <Primary_Keys
	 * name="..."/> </Column>
	 * 
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t2"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * </entry> </entries> </tableName>
	 * 
	 * <tableName name="t3"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="..."/> </Column> <Column IsAutoIncrement="..."
	 * IsNullable="..." Size="..." Type="..." name="..."> <Primary_Keys
	 * name="..."/> </Column> </information> <entries name="EntriesTable">
	 * <entry name="t3"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="tn"> <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="..."/> </Column> <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="..."/> </Column> </information> <entries
	 * name="EntriesTable">
	 * 
	 * <entry name="tn"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName> </tables> <DbInfos
	 * name="informationDbDataType"> <dataType name="type"> <typeClass
	 * name="numericType"> <type_Name bytes="..." max_value="..."
	 * min_value="..." name="..."/> <typeName bytes="..." max_value="..."
	 * min_value="..." name="..."/> <typeName bytes="..." max_value="..."
	 * min_value="..." name="..."/> <typeName bytes="..." max_value="..."
	 * min_value="..." name="..."/>
	 * 
	 * <typeName name="..."/>
	 * 
	 * </typeClass> <typeClass name="dataAndTimeType"> <typeName format="... to
	 * ..." name="..."/> <Type_Name format="... to ..." name="..."/> <typeName
	 * name="..."/>
	 * 
	 * </typeClass> </dataType> </DbInfos> </database>
	 * 
	 * 
	 * 
	 * 
	 * 
	 * @param noeudDataType
	 */

	private void processNodeDataTimeType(Node noeudDataType) throws Exception {
		printMessage("Processing data and time type node");
		Node noeudDataTimeType = ajoutNoeud(noeudDataType, "typeClass",
				"dataAndTime");

		//datetime

		Node noeudDatetime = ajoutNoeud(noeudDataTimeType, "typeName",
				"datetime");
		((Element) noeudDatetime).setAttribute("format",
				"1000-01-01 00:00:00  9999-12-31 23:59:59");

		//date
		Node noeudDate = ajoutNoeud(noeudDataTimeType, "typeName", "date");
		((Element) noeudDate)
				.setAttribute("format", "1000-01-01 to 9999-12-31");

		//timestamp
		Node noeudTimestamp = ajoutNoeud(noeudDataTimeType, "typeName",
				"timestamp");
		((Element) noeudDatetime).setAttribute("format",
				"1000-01-01 to 9999-12-31");

		//time
		Node noeudTime = ajoutNoeud(noeudDataTimeType, "typeName", "time");
		((Element) noeudTime).setAttribute("format", "-838:59:59 to 838:59:59");

		//current_time
		Node noeudCurrentTime = ajoutNoeud(noeudDataTimeType, "typeName",
				"current_time");
		((Element) noeudCurrentTime).setAttribute("format",
				"-838:59:59 to 838:59:59");

		//year
		Node noeudYear = ajoutNoeud(noeudDataTimeType, "typeName", "year");
		((Element) noeudYear).setAttribute("format", "1901 to 2155");

	}

	/**
	 * 
	 * @param noeudInfoDbDataType
	 * 
	 * 
	 * 
	 * 
	 * <database name="agenzia"> - * <tables name="table"> <tableName name="t1">
	 * <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="id_casa"/> </Column>
	 * 
	 * 
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="id_casa"/> </Column>
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t1"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="t2"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="id_casa"/> </Column> <Column IsAutoIncrement="..."
	 * IsNullable="..." Size="..." Type="..." name="..."> <Primary_Keys
	 * name="id_casa"/> </Column>
	 * 
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t2"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * </entry> </entries> </tableName>
	 * 
	 * <tableName name="t3"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="id_casa"/> </Column> <Column IsAutoIncrement="..."
	 * IsNullable="..." Size="..." Type="..." name="..."> <Primary_Keys
	 * name="id_casa"/> </Column> </information> <entries name="EntriesTable">
	 * <entry name="t3"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="tn"> <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="id_casa"/> </Column> <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="id_casa"/> </Column> </information> <entries
	 * name="EntriesTable">
	 * 
	 * <entry name="tn"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName> </tables> <DbInfos
	 * name="informationDbDataType"> <dataType name="type"> </dataType>
	 * </DbInfos> </database>
	 * 
	 * 
	 * 
	 * 
	 * 
	 *  
	 */

	private void processNodeDataType(Node noeudInfoDbDataType) throws Exception {
		printMessage("Processing data type node");
		Node noeudDataType = ajoutNoeud1(noeudInfoDbDataType, "dataType");
		if (getInformationDb) {
			processNodeNumericType(noeudDataType);
			processNodeDataTimeType(noeudDataType);
			processNodeStringType(noeudDataType);
		} else
			return;

	}

	/**
	 * 
	 * @param noeudNomiTab
	 * 
	 * 
	 * 
	 * <database name="agenzia"> - * <tables name="table"> <tableName name="t1">
	 * <information name="informatioField" </information> <entries
	 * name="EntriesTable"> </entries> </tableName>
	 * 
	 * <tableName name="t2"> <information name="informatioField" </information>
	 * <entries name="EntriesTable"> </entries> </tableName>
	 * 
	 * <tableName name="t3"> <information name="informatioField" </information>
	 * <entries name="EntriesTable"> </entries> </tableName>
	 * 
	 * <tableName name="tn">
	 * 
	 * <information name="informatioField" </information> <entries
	 * name="EntriesTable"> </entries> </tableName> </tables>- * <DbInfos
	 * name="informationDbDataType"> </DbInfos> </database>
	 * 
	 * 
	 * 
	 * 
	 *  
	 */

	private void processNodeInformationField(Node noeudNomiTab, String tableName)
			throws Exception {
		printMessage("Processing information field node from tables "+tableName);
		if (tablesToExportStructure.contains(tableName)) {
			Node noeudCol = ajoutNoeud1(noeudNomiTab, "information");
			processNodeColumn(noeudCol);
		}
		if (tablesToExportData.contains(tableName)) {
			Node noeudEntries = ajoutNoeud1(noeudNomiTab, "entries");
			processNodeData(noeudEntries);
		}

	}

	/**
	 * 
	 * 
	 * 
	 * 
	 * <database name="agenzia"> - * <tables name="table"> <tableName name="t1">
	 * <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="id_casa"/> </Column>
	 * 
	 * 
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="id_casa"/> </Column>
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t1"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="t2"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="id_casa"/> </Column> <Column IsAutoIncrement="..."
	 * IsNullable="..." Size="..." Type="..." name="..."> <Primary_Keys
	 * name="id_casa"/> </Column>
	 * 
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t2"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * </entry> </entries> </tableName>
	 * 
	 * <tableName name="t3"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="id_casa"/> </Column> <Column IsAutoIncrement="..."
	 * IsNullable="..." Size="..." Type="..." name="..."> <Primary_Keys
	 * name="id_casa"/> </Column> </information> <entries name="EntriesTable">
	 * <entry name="t3"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="tn"> <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="id_casa"/> </Column> <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="id_casa"/> </Column> </information> <entries
	 * name="EntriesTable">
	 * 
	 * <entry name="tn"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName> </tables> <DbInfos
	 * name="informationDbDataType"> <dataType name="type"> <typeClass
	 * name="numericType"> <type_Name bytes="..." max_value="..."
	 * min_value="..." name="..."/> <typeName bytes="..." max_value="..."
	 * min_value="..." name="..."/> <typeName bytes="..." max_value="..."
	 * min_value="..." name="..."/> <typeName bytes="..." max_value="..."
	 * min_value="..." name="..."/>
	 * 
	 * <typeName name="..."/>
	 * 
	 * </typeClass </dataType> </DbInfos> </database>
	 * 
	 * 
	 * 
	 * 
	 * @param noeudDataType
	 */
	private void processNodeNumericType(Node noeudDataType) throws Exception {
		printMessage("Processing numeric type node");
		Node noeudNumericType = ajoutNoeud(noeudDataType, "typeClass",
				"numeric");
		Node noeudTinyint = ajoutNoeud(noeudNumericType, "typeName", "tinyint");
		((Element) noeudTinyint).setAttribute("bytes", "1");
		((Element) noeudTinyint).setAttribute("min_value", "-128");
		((Element) noeudTinyint).setAttribute("max_value", "127");

		//tinyint_uninsigned
		Node noeudTinyintUn = ajoutNoeud(noeudNumericType, "typeName",
				"tinyintUnnsigned");
		((Element) noeudTinyintUn).setAttribute("bytes", "1");
		((Element) noeudTinyintUn).setAttribute("min_value", "0");
		((Element) noeudTinyintUn).setAttribute("max_value", "255");

		//smallint
		Node noeudSmallint = ajoutNoeud(noeudNumericType, "typeName",
				"smallint");
		((Element) noeudSmallint).setAttribute("bytes", "2");
		((Element) noeudSmallint).setAttribute("min_value", "-32768");
		((Element) noeudSmallint).setAttribute("max_value", "32767");

		//smallint_unsigned
		Node noeudSmallintUn = ajoutNoeud(noeudNumericType, "typeName",
				"smallintUnsigned");
		((Element) noeudSmallintUn).setAttribute("bytes", "2");
		((Element) noeudSmallintUn).setAttribute("min_value", "0");
		((Element) noeudSmallintUn).setAttribute("max_value", "65535");

		//mediumint
		Node noeudMediumint = ajoutNoeud(noeudNumericType, "typeName",
				"mediumint");
		((Element) noeudMediumint).setAttribute("bytes", "3");
		((Element) noeudMediumint).setAttribute("min_value", "-8388608");
		((Element) noeudMediumint).setAttribute("max_value", "8388607");

		//mediumint_unsigned
		Node noeudMediumintUn = ajoutNoeud(noeudNumericType, "typeName",
				"mediumintUnsigned");
		((Element) noeudMediumintUn).setAttribute("bytes", "3");
		((Element) noeudMediumintUn).setAttribute("min_value", "0");
		((Element) noeudMediumintUn).setAttribute("max_value", "16777215");

		//int o integer
		Node noeudInteger = ajoutNoeud(noeudNumericType, "typeName", "integer");
		((Element) noeudInteger).setAttribute("bytes", "4");
		((Element) noeudInteger).setAttribute("min_value", "0");
		((Element) noeudInteger).setAttribute("max_value", "4294967295");

		//int
		Node noeudInt = ajoutNoeud(noeudNumericType, "typeName", "int");
		((Element) noeudInt).setAttribute("bytes", "4");
		((Element) noeudInt).setAttribute("min_value", "0");
		((Element) noeudInt).setAttribute("max_value", "4294967295");

		//bigint
		Node noeudBigInt = ajoutNoeud(noeudNumericType, "typeName", "bigint");
		((Element) noeudBigInt).setAttribute("bytes", "8");
		((Element) noeudBigInt).setAttribute("min_value",
				"-9223372036854775808");
		((Element) noeudBigInt)
				.setAttribute("max_value", "9223372036854775807");

		//bigint unsigned
		Node noeudBigIntUn = ajoutNoeud(noeudNumericType, "typeName",
				"bigintUunsigned");
		((Element) noeudBigIntUn).setAttribute("bytes", "8");
		((Element) noeudBigIntUn).setAttribute("min_value", "0");
		((Element) noeudBigIntUn).setAttribute("max_value",
				"18446744073709551615");

		//float(m,d)
		Node noeudFloat = ajoutNoeud(noeudNumericType, "typeName", "float(m,d)");
		((Element) noeudFloat).setAttribute("bytes", "4");
		((Element) noeudFloat)
				.setAttribute(
						"interval",
						"-1.7976931348623157E+308 -2.2250738585072014E-308, 0, 2.2250738585072014E-308  1.7976931348623157E+308'");

		//decimal(m,d)
		Node noeudDecimal = ajoutNoeud(noeudNumericType, "typeName",
				"decimal(m,d)");
		((Element) noeudDecimal).setAttribute("bytes", "8");
		((Element) noeudDecimal).setAttribute("min_value", "0");
		((Element) noeudDecimal).setAttribute("max_value",
				"18446744073709551615");

		//numeric(m,d)
		Node noeudNumeric = ajoutNoeud(noeudNumericType, "typeName",
				"numeric(m,d)");
		((Element) noeudNumeric).setAttribute("bytes", "8");
		((Element) noeudNumeric).setAttribute("min_value", "0");
		((Element) noeudNumeric).setAttribute("max_value",
				"18446744073709551615");

		//zerofill
		Node noeudZerofill = ajoutNoeud(noeudNumericType, "typeName",
				"zerofill");

	}

	/**
	 * 
	 * @param noeudNomeCol
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * <database name="agenzia"> - * <tables name="table"> <tableName name="t1">
	 * <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="id_casa"/> </Column>
	 * 
	 * 
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="id_casa"/> </Column>
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t1"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="t2"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="..."/> </Column> <Column IsAutoIncrement="..."
	 * IsNullable="..." Size="..." Type="..." name="..."> <Primary_Keys
	 * name="..."/> </Column>
	 * 
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t2"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * </entry> </entries> </tableName>
	 * 
	 * <tableName name="t3"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="..."/> </Column> <Column IsAutoIncrement="..."
	 * IsNullable="..." Size="..." Type="..." name="..."> <Primary_Keys
	 * name="..."/> </Column> </information> <entries name="EntriesTable">
	 * <entry name="t3"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="tn"> <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="..."/> </Column> <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="..."/> </Column> </information> <entries
	 * name="EntriesTable">
	 * 
	 * <entry name="tn"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName> </tables> <DbInfos
	 * name="informationDbDataType"> </DbInfos> </database>
	 * 
	 * 
	 * 
	 *  
	 */

	private void processNodePrimaryKeys(Node noeudNomeCol) throws Exception {
		printMessage("Processing primary keys node");
		ResultSet primaria = null;
		try {
			primaria = dbmd.getPrimaryKeys(null, null, tableName);
		} catch (SQLException e) {
			if (continueOnErrorGeneral)
				printError("Error creating tree, string SQL:\n"+e.getMessage());
			else
				throw new Exception("Error creating tree, string SQL:\n"+e.getMessage());
		}

		try {
			while (primaria.next()) {

				Node noeudInfoChiavi = ajoutNoeud(noeudNomeCol, "primaryKeys",
						primaria.getString("COLUMN_NAME"));
			}
		} catch (SQLException e1) {
			if (continueOnErrorGeneral)
				printError("Error creating tree, string SQL:\n"+e1.getMessage());
			else
				throw new Exception("Error creating tree, string SQL:\n"+e1.getMessage());
		}
	}

	/**
	 * 
	 * @param noeudDataType
	 *  * <database name="agenzia"> - * <tables name="table">
	 * <tableName name="t1"> <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="..."/> </Column>
	 * 
	 * 
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="..."/> </Column>
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t1"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/> <data
	 * ...="..."/> <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="t2"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="..."/> </Column> <Column IsAutoIncrement="..."
	 * IsNullable="..." Size="..." Type="..." name="..."> <Primary_Keys
	 * name="..."/> </Column>
	 * 
	 * 
	 * </information> <entries name="EntriesTable"> <entry name="t2"> <data
	 * ...="..."/> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * </entry> </entries> </tableName>
	 * 
	 * <tableName name="t3"> <information name="informatioField" <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="..."/> </Column> <Column IsAutoIncrement="..."
	 * IsNullable="..." Size="..." Type="..." name="..."> <Primary_Keys
	 * name="..."/> </Column> </information> <entries name="EntriesTable">
	 * <entry name="t3"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName>
	 * 
	 * <tableName name="tn"> <information name="informatioField"
	 * 
	 * <Column IsAutoIncrement="..." IsNullable="..." Size="..." Type="..."
	 * name="..."> <Primary_Keys name="..."/> </Column> <Column
	 * IsAutoIncrement="..." IsNullable="..." Size="..." Type="..." name="...">
	 * <Primary_Keys name="..."/> </Column> </information> <entries
	 * name="EntriesTable">
	 * 
	 * <entry name="tn"> <data ...="..."/> <data ...="..."/> <data ...="..."/>
	 * <data ...="..."/> </entry> </entries> </tableName> </tables> <DbInfos
	 * name="informationDbDataType"> <dataType name="type"> <typeClass
	 * name="numericType"> <type_Name bytes="..." max_value="..."
	 * min_value="..." name="..."/> <typeName bytes="..." max_value="..."
	 * min_value="..." name="..."/> <typeName bytes="..." max_value="..."
	 * min_value="..." name="..."/> <typeName bytes="..." max_value="..."
	 * min_value="..." name="..."/>
	 * 
	 * <typeName name="..."/>
	 * 
	 * </typeClass <typeClass name="dataAndTimeType"> <typeName format="... to
	 * ..." name="..."/> <type_Name format="... to ..." name="..."/> <typeName
	 * name="..."/>
	 * 
	 * </typeClass> <typeClass name="stringType"> <typeName bytes="..."
	 * max_value="..." min_value="..." name="..."/>
	 * 
	 * <typeName name="..."/>
	 * 
	 * <typeName bytes="..." max_value="..." min_value="..." name="..."/>
	 * 
	 * <typeName name="..."/>
	 * 
	 * </typeClass </dataType> </DbInfos> </database>
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 * 
	 *  
	 */

	private void processNodeStringType(Node noeudDataType) throws Exception {
		printMessage("Processing string type node");
		Node noeudStringType = ajoutNoeud(noeudDataType, "typeClass", "string");

		/*
		 * type char
		 */

		Node noeudChar = ajoutNoeud(noeudStringType, "typeName", "char");
		((Element) noeudChar).setAttribute("bytes", "8");
		((Element) noeudChar).setAttribute("min_value", "0");
		((Element) noeudChar).setAttribute("max_value", "255");
		/*
		 * type varchar
		 */
		Node noeudVarchar = ajoutNoeud(noeudStringType, "typeName", "varchar");
		((Element) noeudVarchar).setAttribute("bytes", "1,3,5");
		((Element) noeudVarchar).setAttribute("min_value", "0");
		((Element) noeudVarchar).setAttribute("max_value", "255");
		/*
		 * type binary
		 */
		Node noeudBinary = ajoutNoeud(noeudStringType, "typeName", "binary");
		((Element) noeudBinary).setAttribute("bytes", "1,3,5");

		/*
		 * type varbinary
		 */
		Node noeudVarbinary = ajoutNoeud(noeudStringType, "typeName",
				"varbinary");

		/*
		 * type blob
		 */
		Node noeudBlob = ajoutNoeud(noeudStringType, "typeName", "blob");
		((Element) noeudBlob).setAttribute("bytes", "longeur + 2 bytes");
		((Element) noeudBlob).setAttribute("min_value", "0");
		((Element) noeudBlob).setAttribute("max_value", "65535");

		/*
		 * type tinyblob
		 */
		Node noeudTinyblob = ajoutNoeud(noeudStringType, "typeName", "tinyblob");
		((Element) noeudTinyblob).setAttribute("bytes", "longeur + 1 bytes");
		((Element) noeudTinyblob).setAttribute("min_value", "0");
		((Element) noeudTinyblob).setAttribute("max_value", "255");

		/*
		 * mediumblob
		 */
		Node noeudMediumblob = ajoutNoeud(noeudStringType, "typeName",
				"mediumblob");
		((Element) noeudMediumblob).setAttribute("bytes", "longeur + 3 bytes");
		((Element) noeudMediumblob).setAttribute("min_value", "0");
		((Element) noeudMediumblob).setAttribute("max_value", "16777215");

		/*
		 * type longblob
		 */
		Node noeudLongblob = ajoutNoeud(noeudStringType, "typeName", "Longblob");
		((Element) noeudLongblob).setAttribute("bytes", "longeur + 4 bytes");
		((Element) noeudLongblob).setAttribute("min_value", "0");
		((Element) noeudLongblob).setAttribute("max_value", "42949672950");

		/*
		 * type text
		 */
		Node noeudText = ajoutNoeud(noeudStringType, "typeName", "text");
		((Element) noeudText).setAttribute("bytes", "longeur + 2 bytes");
		((Element) noeudText).setAttribute("min_value", "0");
		((Element) noeudText).setAttribute("max_value", "65535");

		/*
		 * type tinytext
		 */
		Node noeudTinytext = ajoutNoeud(noeudStringType, "typeName", "tinytext");
		((Element) noeudTinytext).setAttribute("bytes", "longeur + 1 bytes");
		((Element) noeudTinytext).setAttribute("min_value", "0");
		((Element) noeudTinytext).setAttribute("max_value", "255");

		/*
		 * type mediumtext
		 */
		Node noeudMediumtext = ajoutNoeud(noeudStringType, "typeName",
				"mediumtext");
		((Element) noeudMediumtext).setAttribute("bytes", "longeur + 3 bytes");
		((Element) noeudMediumtext).setAttribute("min_value", "0");
		((Element) noeudMediumtext).setAttribute("max_value", "16777215");

		/*
		 * type longtext
		 */
		Node noeudLongtext = ajoutNoeud(noeudStringType, "typeName", "longtext");
		((Element) noeudLongtext).setAttribute("bytes", "longeur + 4 bytes");
		((Element) noeudLongtext).setAttribute("min_value", "0");
		((Element) noeudLongtext).setAttribute("max_value", "42949672950");

		/*
		 * type enum
		 */
		Node noeudEnum = ajoutNoeud(noeudStringType, "typeName", "enum");

		/*
		 * type null
		 */
		Node noeudNull = ajoutNoeud(noeudStringType, "typeName", "null");

		/*
		 * type set
		 */
		Node noeudSet = ajoutNoeud(noeudStringType, "typeName", "set");

	}

	/**
	 * (non-Javadoc)
	 * 
	 * @see migration.ImportInterface#setTablesToExportData(java.util.Vector)
	 */

	public void setTablesToExportData(Vector tables) {
		this.tablesToExportData = tables;

		// TODO Auto-generated method stub

	}

	/**
	 * (non-Javadoc)
	 * 
	 * @see migration.ImportInterface#setTablesToExportStructure(java.util.Vector)
	 */
	public void setTablesToExportStructure(Vector tables) {
		this.tablesToExportStructure = tables;

	}

	/**
	 * (non-Javadoc)
	 * 
	 * @see migration.ImportInterface#setContinueOnTableNotFound()
	 */
	public void setContinueOnTableNotFound() {
		this.continueOnTableNotFound = true;

	}

	public void setContinueOnErrorGeneral() {
		this.continueOnErrorGeneral = true;
	}

	public void setContinueOnDatabaseNotFound() {
		this.continueOnDatabaseNotFound = true;
	}

	public void setInformationDatabaseExport() {
		this.getInformationDb = true;
	}

	/**
	 * (non-Javadoc)
	 * 
	 * @see migration.ImportInterface#exportData()
	 */
	public String exportData() throws Exception {
		doExportData();
		return resultXML;
	}
	
	public void forceCloseConnection() {
		try {
			conn.close();
			printMessage("Done closing connection");
		} catch (Exception e) {
			try {
				printError("Error closing connection to database");
			} catch (Exception e1) {
			}
		}
	}

	/**
	 * (non-Javadoc)
	 * 
	 * @see migration.ImportInterface#initConnection(java.lang.String,
	 *      java.lang.String, java.lang.String, java.lang.String,
	 *      java.lang.String)
	 */
	public void initConnection(String serveraddress, String serverport,
			String defaultdb, String username, String password) throws Exception{
		Properties prop = new java.util.Properties();
		prop.put("user", username);
		if (!(password.equals("")))
			prop.put("password", password);

		prop.put("useUnicode", "true");

		if (defaultdb.equals(""))
			defaultdb = "";
		initConnection("jdbc:mysql://" + serveraddress + ":" + serverport + "/"
				+ defaultdb, prop);
		
	}
}
