package org.jdom.contrib.c14n;

import java.util.Comparator;

import org.jdom.Attribute;

class AttributeComparator implements Comparator {

	public int compare(Object o1, Object o2) {
		Attribute a1 = (Attribute) o1;
		Attribute a2 = (Attribute) o2;

		String namespace1 = a1.getNamespaceURI();
		String namespace2 = a2.getNamespaceURI();
		if (namespace1.equals(namespace2)) {
			return a1.getName().compareTo(a2.getName());
		} else if (namespace1.equals("")) {
			return -1;
		} else if (namespace2.equals("")) {
			return 1;
		} else { // compare namespace URIs
			return namespace1.compareTo(namespace2);
		}

	}

}